######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

BEGIN { $| = 1; print "1..14\n"; };
END {print "not ok 1\n" unless $loaded;}
use Math::Quaternion qw(qtrn);
$loaded = 1;
print "ok 1\n";

######################### End of black magic.

use Config;
$^W = 1;

my $re_1 = qtrn(1);
my $im_i = qtrn(0, 1);
my $im_j = qtrn(0, 0, 1);
my $im_k = qtrn(0, 0, 0, 1);
my $ones = qtrn(1, 1, 1, 1);
my $unit = qtrn(0.5, 0.5, 0.5, 0.5);

my $q1 = qtrn(2, 3, 5, 7);
$q2 = $q1 * $re_1;
print "not" if ("$q2" ne "2 + 3i + 5j + 7k");
print "ok 2\n";

my $q3 = $re_1 * $q1;
print "not" if ("$q3" ne "2 + 3i + 5j + 7k");
print "ok 3\n";

$q4 = $q1 * $im_i;
print "not" if ("$q4" ne "-3 + 2i + 7j + -5k");
print "ok 4\n";

my $q5 = $im_i * $q1;
print "not" if ("$q5" ne "-3 + 2i + -7j + 5k");
print "ok 5\n";

$q6 = $q1 * $im_j;
print "not" if ("$q6" ne "-5 + -7i + 2j + 3k");
print "ok 6\n";

my $q7 = $im_j * $q1;
print "not" if ("$q7" ne "-5 + 7i + 2j + -3k");
print "ok 7\n";

$q8 = $q1 * $im_k;
print "not" if ("$q8" ne "-7 + 5i + -3j + 2k");
print "ok 8\n";

my $q9 = $im_k * $q1;
print "not" if ("$q9" ne "-7 + -5i + 3j + 2k");
print "ok 9\n";

my $q10 = $q2;
$q10 *= $q2;
print "not" if ("$q10" ne "-79 + 12i + 20j + 28k");
print "ok 10\n";

my $q11 = $q2 * $ones;
print "not" if ("$q11" ne "-13 + 3i + 11j + 7k");
print "ok 11\n";

my $q12 = $ones * $q2;
print "not" if ("$q12" ne "-13 + 7i + 3j + 11k");
print "ok 12\n";

my $q13 = $q2 * $unit;
print "not" if ("$q13" ne "-6.5 + 1.5i + 5.5j + 3.5k");
print "ok 13\n";

my $q14 = $unit * $q2;
print "not" if ("$q14" ne "-6.5 + 3.5i + 1.5j + 5.5k");
print "ok 14\n";

1;
