######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

BEGIN { $| = 1; print "1..6\n"; };
END {print "not ok 1\n" unless $loaded;}
use Math::Quaternion qw(qtrn qtrn_vrotate);
$loaded = 1;
print "ok 1\n";

######################### End of black magic.

use Config;
$^W = 1;

my $flerr = 0.00000000001;
my $a180 = 4 * atan2(1, 1);
my $a90 = 2 * atan2(1, 1);
my $a60 = (4 * atan2(1, 1))/3;

my $re_1 = qtrn(1);
my $im_i = qtrn(0, 1);
my $im_j = qtrn(0, 0, 1);
my $im_k = qtrn(0, 0, 0, 1);

my $rotate_180_j = qtrn_vrotate($a180, 0, 1, 0);
my $rotate_90_j = qtrn_vrotate($a90, 0, 1, 0);
my $rotate_60_j = qtrn_vrotate($a60, 0, 1, 0);

#
# Test abs().
#
print "not" if (abs qtrn(0, 3, 4, 12) != 13);
print "ok 2\n";

#
# Test qtrn_vrotate() and rotate().
#
my($q1, $q2, $q3);
$q1 = $im_i->rotate($rotate_180_j);

$q2 = $im_i->rotate($rotate_90_j);
$q2 = $q2->rotate($rotate_90_j);

$q3 = $im_i->rotate($rotate_60_j);
$q3 = $q3->rotate($rotate_60_j);
$q3 = $q3->rotate($rotate_60_j);

print "not" if (abs($q1 - $q2) > $flerr or abs($q1 - $q3) > $flerr);
print "ok 3\n";

#
# Test qtrn_vrotate() and rotate() again.
#
$q1 = $im_i->rotate(-$rotate_180_j);
$q2 = $im_i->rotate(-$rotate_90_j);
$q2 = $q2->rotate(-$rotate_90_j);

print "not" if (abs($q1 - $q2) > $flerr);
print "ok 4\n";

#
# See if the multiplication of rotations comes out right.
#
my($rot_3_times_60) = $rotate_60_j * $rotate_60_j * $rotate_60_j;
$q1 = $im_i->rotate($rotate_180_j);
$q2 = $im_i->rotate($rot_3_times_60);

print "not" if (abs($q1 - $q2) > $flerr);
print "ok 5\n";

$q1 = qtrn(0, 1, 1, 1);
$q2 = $q1->rotate($rotate_90_j);
$q3 = (1/$rotate_90_j) * $q1 * $rotate_90_j;

print "not" if (abs($q2 - $q3) > $flerr);
print "ok 6\n";
1;
